This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Revert change 23843.
[perl5.git] / t / comp / require.t
index d4c9d8c..29f5436 100755 (executable)
@@ -2,12 +2,18 @@
 
 BEGIN {
     chdir 't' if -d 't';
-    unshift @INC, ('.', '../lib');
+    @INC = '.';
+    push @INC, '../lib';
 }
 
 # don't make this lexical
 $i = 1;
-print "1..16\n";
+
+my $Is_EBCDIC = (ord('A') == 193) ? 1 : 0;
+my $Is_UTF8   = (${^OPEN} || "") =~ /:utf8/;
+my $total_tests = 44;
+if ($Is_EBCDIC || $Is_UTF8) { $total_tests = 41; }
+print "1..$total_tests\n";
 
 sub do_require {
     %INC = ();
@@ -19,17 +25,37 @@ sub do_require {
 sub write_file {
     my $f = shift;
     open(REQ,">$f") or die "Can't write '$f': $!";
+    binmode REQ;
+    use bytes;
     print REQ @_;
-    close REQ;
+    close REQ or die "Could not close $f: $!";
 }
 
+eval {require 5.005};
+print "# $@\nnot " if $@;
+print "ok ",$i++,"\n";
+
+eval { require 5.005 };
+print "# $@\nnot " if $@;
+print "ok ",$i++,"\n";
+
+eval { require 5.005; };
+print "# $@\nnot " if $@;
+print "ok ",$i++,"\n";
+
+eval {
+    require 5.005
+};
+print "# $@\nnot " if $@;
+print "ok ",$i++,"\n";
+
 # new style version numbers
 
 eval { require v5.5.630; };
 print "# $@\nnot " if $@;
 print "ok ",$i++,"\n";
 
-eval { require v10.0.2; };
+eval { require 10.0.2; };
 print "# $@\nnot " unless $@ =~ /^Perl v10\.0\.2 required/;
 print "ok ",$i++,"\n";
 
@@ -37,31 +63,30 @@ eval q{ use v5.5.630; };
 print "# $@\nnot " if $@;
 print "ok ",$i++,"\n";
 
-eval q{ use v10.0.2; };
+eval q{ use 10.0.2; };
 print "# $@\nnot " unless $@ =~ /^Perl v10\.0\.2 required/;
 print "ok ",$i++,"\n";
 
-my $ver = v5.5.630;
+my $ver = 5.005_63;
 eval { require $ver; };
 print "# $@\nnot " if $@;
 print "ok ",$i++,"\n";
 
-$ver = v10.0.2;
+# check inaccurate fp
+$ver = 10.2;
 eval { require $ver; };
-print "# $@\nnot " unless $@ =~ /^Perl v10\.0\.2 required/;
+print "# $@\nnot " unless $@ =~ /^Perl v10\.200 required/;
 print "ok ",$i++,"\n";
 
-print "not " unless v5.5.1 gt v5.5;
-print "ok ",$i++,"\n";
-
-print "not " unless 5.005_01 > v5.5;
+$ver = 10.000_02;
+eval { require $ver; };
+print "# $@\nnot " unless $@ =~ /^Perl v10\.0\.20 required/;
 print "ok ",$i++,"\n";
 
-print "not " unless 5.005_64 - v5.5.640 < 0.0000001;
+print "not " unless 5.5.1 gt v5.5;
 print "ok ",$i++,"\n";
 
 {
-    use utf8;
     print "not " unless v5.5.640 eq "\x{5}\x{5}\x{280}";
     print "ok ",$i++,"\n";
 
@@ -83,6 +108,24 @@ do_require "0;\n";
 print "# $@\nnot " unless $@ =~ /did not return a true/;
 print "ok ",$i++,"\n";
 
+print "not " if exists $INC{'bleah.pm'};
+print "ok ",$i++,"\n";
+
+my $flag_file = 'bleah.flg';
+# run-time error in require
+for my $expected_compile (1,0) {
+    write_file($flag_file, 1);
+    print "not " unless -e $flag_file;
+    print "ok ",$i++,"\n";
+    write_file('bleah.pm', "unlink '$flag_file' or die; \$a=0; \$b=1/\$a; 1;\n");
+    print "# $@\nnot " if eval { require 'bleah.pm' };
+    print "ok ",$i++,"\n";
+    print "not " unless -e $flag_file xor $expected_compile;
+    print "ok ",$i++,"\n";
+    print "not " unless exists $INC{'bleah.pm'};
+    print "ok ",$i++,"\n";
+}
+
 # compile-time failure in require
 do_require "1)\n";
 # bison says 'parse error' instead of 'syntax error',
@@ -90,12 +133,73 @@ do_require "1)\n";
 print "# $@\nnot " unless $@ =~ /(syntax|parse) error/mi;
 print "ok ",$i++,"\n";
 
+# previous failure cached in %INC
+print "not " unless exists $INC{'bleah.pm'};
+print "ok ",$i++,"\n";
+write_file($flag_file, 1);
+write_file('bleah.pm', "unlink '$flag_file'; 1");
+print "# $@\nnot " if eval { require 'bleah.pm' };
+print "ok ",$i++,"\n";
+print "# $@\nnot " unless $@ =~ /Compilation failed/i;
+print "ok ",$i++,"\n";
+print "not " unless -e $flag_file;
+print "ok ",$i++,"\n";
+print "not " unless exists $INC{'bleah.pm'};
+print "ok ",$i++,"\n";
+
 # successful require
 do_require "1";
 print "# $@\nnot " if $@;
 print "ok ",$i++,"\n";
 
-END { 1 while unlink 'bleah.pm'; }
+# do FILE shouldn't see any outside lexicals
+my $x = "ok $i\n";
+write_file("bleah.do", <<EOT);
+\$x = "not ok $i\\n";
+EOT
+do "bleah.do";
+dofile();
+sub dofile { do "bleah.do"; };
+print $x;
+
+# Test that scalar context is forced for require
+
+write_file('bleah.pm', <<'**BLEAH**'
+print "not " if !defined wantarray || wantarray ne '';
+print "ok $i - require() context\n";
+1;
+**BLEAH**
+);
+                              delete $INC{"bleah.pm"}; ++$::i;
+$foo = eval q{require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+@foo = eval q{require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+       eval q{require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+       eval q{$_=$_+2;require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+$foo = eval  {require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+@foo = eval  {require bleah}; delete $INC{"bleah.pm"}; ++$::i;
+       eval  {require bleah};
+
+# UTF-encoded things - skipped on EBCDIC machines and on UTF-8 input
+
+if ($Is_EBCDIC || $Is_UTF8) { exit; }
+
+my $utf8 = chr(0xFEFF);
+
+$i++; do_require(qq(${utf8}print "ok $i\n"; 1;\n));
+
+sub bytes_to_utf16 {
+    my $utf16 = pack("$_[0]*", unpack("C*", $_[1]));
+    return @_ == 3 && $_[2] ? pack("$_[0]", 0xFEFF) . $utf16 : $utf16;
+}
+
+$i++; do_require(bytes_to_utf16('n', qq(print "ok $i\\n"; 1;\n), 1)); # BE
+$i++; do_require(bytes_to_utf16('v', qq(print "ok $i\\n"; 1;\n), 1)); # LE
+
+END {
+    1 while unlink 'bleah.pm';
+    1 while unlink 'bleah.do';
+    1 while unlink 'bleah.flg';
+}
 
 # ***interaction with pod (don't put any thing after here)***